CONST
  fnamesize = 20;

TYPE
  filename = STRING[fnamesize];

VAR
  fin,fout,treef: filename;
  reply: CHAR;
  ok: BOOLEAN;

PROCEDURE title(titl:STRING);
BEGIN
  ClrScr;
  WRITELN(titl);
  {$IFNDEF factor}
     WRITELN('Written by J.Felsenstein, Genetics Dept., Univ.Washington, Seattle, WA 98195');
  {$ELSE}
     WRITELN('Written by C.Meacham, Botany Dept., Univ.Georgia, Athens, GA 30602');
  {$ENDIF}
END;  (* title *)

PROCEDURE openfiles;
BEGIN
  REPEAT
    WRITELN;
    WRITE ('Enter input file: ');
    READLN (fin);
    ASSIGN (infile,fin);
    {$I-} RESET (infile) {$I+};
    ok := (IOResult = 0);
    IF NOT ok THEN WRITE ('File "',fin,'" not found');
  UNTIL ok;
  {$IFNDEF move}
  REPEAT
    WRITELN;
    WRITE ('Enter output file: ');
    READLN (fout);
    ASSIGN (outfile,fout);
    {$I-} RESET (outfile) {$I+};
    ok := (IOResult <> 0);
    IF NOT ok THEN
       BEGIN
         WRITE ('File "',fout,'" already exists. Overwrite (Y/N)? ');
         READLN (reply);
         ok := (UpCase(reply) = 'Y');
       END;
  UNTIL ok;
  REWRITE (outfile);
  {$ENDIF}
END;  (* openfiles *)

{$IFNDEF factor}
PROCEDURE opentreefile;
BEGIN
  REPEAT
    WRITE ('Enter treefile: ');
    READLN (treef);
    ASSIGN (treefile,treef);
    {$I-} RESET (treefile) {$I+};
    ok := (IOResult <> 0);
    IF NOT ok THEN
       BEGIN
         WRITE ('Treefile "',treef,'" already exists. Overwrite (Y/N)? ');
         READLN (reply);
         ok := (UpCase(reply) = 'Y');
       END;
  UNTIL ok;
  REWRITE (treefile);
END; (* opentreefile *)
{$ENDIF}

PROCEDURE finish;
BEGIN
  WRITELN ('- done -');
  {$IFDEF WINDOWS}
  WRITELN;
  WRITELN ('Press Alt+F4 to close this window');
  {$ENDIF}
END;